# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2010-2011, Tashilgostar co. , All Rights Reserved
#        Nima ghorbani <nima.g.67@gmail.com> (http://ir.linkedin.com/in/nimaghi)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields, osv
from datetime import datetime
import urllib
from tools import ustr as u
from tools import ustr 
from tools.translate import _
from dateutil.relativedelta import relativedelta
import subprocess
import socket

import smtplib
from email.MIMEText import MIMEText
from email.MIMEBase import MIMEBase
from email.MIMEMultipart import MIMEMultipart
from email.Header import Header
from email.Utils import formatdate, COMMASPACE
from email import Encoders

import tools

try:
    from html2text import html2text
except ImportError:
    html2text = None

next_action=1

import crm 


class communication_server(osv.osv):
    _name = 'comm_server'
    _description = "Communication Server"
    _order = "id desc"
    _columns = {
        'name' : fields.char('Server Name', size=256, required=True, readonly=True, states={'draft':[('readonly', False)]}),
        'active':fields.boolean('Active'),
        'username' : fields.char('User Name', size=256, required=True,readonly=True, states={'draft':[('readonly', False)]}),
        'password' : fields.char('Password', size=1024, invisible=True,required=True,readonly=True, states={'draft':[('readonly', False)]}),
        'state':fields.selection([
            ('draft', 'Not Confirmed'),
            ('waiting', 'Waiting for Verification'),
            ('done', 'Confirmed'),
            ], 'State', select=True, readonly=True),
        'host' : fields.char('Server', required=True,size=256,  readonly=True, states={'draft':[('readonly', False)]}),
        'port' : fields.char('Port', size=256, readonly=True, states={'draft':[('readonly', False)]}),
        'type':fields.selection([
            ('email', 'Email POP Server'),
            ('sms', 'SMS Server'),
            ('fax', 'Fax Server'),
            ], 'Server Type', select=True, readonly=False,required=True),
        'admin_pass':fields.char('Admin Password',invisible=True,help='Fax Server Admin Password',size=250),
        'note': fields.text('Description'),
        'allowed_users': fields.many2many('res.users', 'res_groups_users_rel', 'gid', 'uid', 'Users'),
        'prefix' : fields.char('PBX Prefix', size=256, readonly=True, states={'draft':[('readonly', False)]}),
        'local_area_code' : fields.char('Local Area Code', size=256, readonly=True, states={'draft':[('readonly', False)]}),
        'archive_folder' : fields.char('Archive Folder', size=512, readonly=True, states={'draft':[('readonly', False)]}),
        'email_from' : fields.char('From', size=256, readonly=True, states={'draft':[('readonly', False)]}),
        'email_replyto' : fields.char('Reply To', size=256, readonly=True,states={'draft':[('readonly', False)]}),
        'default_server' : fields.boolean('Default Server', readonly=True,states={'draft':[('readonly', False)]}),
        'sms_from': fields.char('From', size=32, readonly=True, states={'draft':[('readonly', False)]}),
        #'message_ids': fields.one2many('mailgate.message', 'server_id', 'Messages', readonly=True),
    }
    _defaults = {
        'state': lambda *a: "draft",
        'active': lambda *a: True,
        'prefix': lambda *a: None,
        'default_server': lambda *a: False,
        'sms_from': lambda *a: '',
        #'user_id': lambda self, cr, uid, ctx: uid,
    }
    def u(self,obj, encoding='utf-8'):
        if isinstance(obj, basestring):
            if not isinstance(obj, unicode):
                obj = unicode(obj, encoding)
        return obj
    def _is_correct_mobile(self,mobile=False):
        mobiles=mobile.split(';')
        for mobile in mobiles:
            if len(mobile)==len('09143079735'):
                if mobile.isdigit():
                    continue
                else :return False
            else :return False
        return True 

    def _send_sms(self,cr,uid,server_id,smsobject):
        to,text=smsobject.to,smsobject.content or ''
        if server_id.type != 'sms':
            ans={'message':'Wrong Server Chosen For This Type Of Communication',
                 'state':'error',
                 'next_act':(datetime.now() + relativedelta(minutes=next_action)).strftime('%Y-%m-%d %H:%M:%S'),
                 'job_id':None
                 }
            if smsobject.try_count >=1:
                server_ids = self.pool.get('comm_server').search(cr, uid, [('type','=','sms'),('default_server','=',True)])
                server_id=self.pool.get('comm_server').browse(cr,uid,server_ids.pop())
                self.pool.get('comm_queue').write(cr,uid,smsobject.id,{'server_id':server_id.id,})
            else:return ans
        try:
            url=server_id.host+"Username="+server_id.username+'&Password='+server_id.password
            if server_id.sms_from:url=url+'&from='+server_id.sms_from
            text=u("&Text=")+text
            if not self._is_correct_mobile(to):
                raise TypeError,u'شماره موبایل اشتباه!'.encode('utf-8')
            to=u("&To=")+u(to)
            message = url+to+text
            message = message.encode('utf-8')
            sms=urllib.urlopen(message)
            message=_("Successfully sent!")
            state='sent'
            n_act=None
        except TypeError,e:
            message=e
            state='error'
            n_act=None
        except IOError,e:
            message=e
            state='error'
            n_act=(datetime.now() + relativedelta(minutes=next_action)).strftime('%Y-%m-%d %H:%M:%S')

        ans={'message':message,
             'state':state,
             'next_act':n_act}
        return ans
    def _config_fax_number(self,number,server_id):
        numbers=number.split(';')
        prefix,number=None,None
        try:
            for number in numbers:
                number=tuple(number.split('-'))
                prefix,number=number
                prefix =((prefix.startswith('0') and prefix!=server_id.local_area_code) and prefix) or ''
                number=(not number.startswith('0') and number) or None
                if number:
                    number=server_id.prefix+str(prefix)+number
                    return number
            return None
        except:
            return None
    def _send_fax(self,cr,uid,server_id,faxobject=None):
        to=self._config_fax_number(faxobject.to,server_id)

        if server_id.type != 'fax':
            ans={'message':'Wrong Server Chosen For This Type Of Communication',
                 'state':'error',
                 'next_act':(datetime.now() + relativedelta(minutes=next_action)).strftime('%Y-%m-%d %H:%M:%S'),
                 'job_id':None
                 }
            if faxobject.try_count >=1:
                server_ids = self.pool.get('comm_server').search(cr, uid, [('type','=','fax'),('default_server','=',True)])
                server_id=self.pool.get('comm_server').browse(cr,uid,server_ids.pop())
                self.pool.get('comm_queue').write(cr,uid,faxobject.id,{'server_id':server_id.id,})
            else:return ans
        if not to:
            ans={'message':'Wrong Fax Number! %s'%faxobject.to,
                 'state':'error',
                 'next_act':(datetime.now() + relativedelta(minutes=next_action)).strftime('%Y-%m-%d %H:%M:%S'),
                 'job_id':None
                 }
            return ans

        cmd='sendfax '+(faxobject.advanced_options or '')+'-s a4 -h 127.0.0.1 -n -d '+to+' '+server_id.archive_folder+faxobject.store_fname
        cmd = cmd.encode('utf8')
        out=False
        pipe = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)
        sts = pipe.wait()
        out = pipe.stdout.read() + pipe.stderr.read()
        if out.startswith('request id is '):
            ans={'message':out,
                 'state':'sent',
                 'next_act':None,
                 'job_id':out.split()[3]
                 }
        else:
            ans={'message':out,
                 'state':'error',
                 'next_act':(datetime.now() + relativedelta(minutes=next_action)).strftime('%Y-%m-%d %H:%M:%S'),
                 'job_id':None
                 }
        return ans
    def _send_mail(self,cr,uid,smtp_server,emailobject):
        class logthis(object):
            def __init__(self):
                self.log=''
            def write(self, s):
                self.log+=s
        if smtp_server.type != 'email':
            ans={'message':'Wrong Server Chosen For This Type Of Communication',
                 'state':'error',
                 'next_act':(datetime.now() + relativedelta(minutes=next_action)).strftime('%Y-%m-%d %H:%M:%S'),
                 'job_id':None
                 }
            if emailobject.try_count >=1:
                server_ids = self.pool.get('comm_server').search(cr, uid, [('type','=','email'),('default_server','=',True)])
                smtp_server=self.pool.get('comm_server').browse(cr,uid,server_ids.pop())
                self.pool.get('comm_queue').write(cr,uid,emailobject.id,{'server_id':smtp_server.id,})
            else:return ans
        email_from=ustr(smtp_server.email_from).encode('utf-8')
        body=emailobject.content
        subtype=emailobject.email_type
        reply_to=smtp_server.email_replyto
        email_to=emailobject.to
        #email_bcc=emailobject.email_bcc
        email_bcc=None
        subject=emailobject.email_subject

        if not body: body = u''

        email_body = ustr(body).encode('utf-8')
        email_text = MIMEText(email_body,_subtype=subtype,_charset='utf-8')

        msg = MIMEMultipart()

        msg['Subject'] = Header(ustr(subject), 'utf-8')
        msg['From'] = email_from
        del msg['Reply-To']
        if reply_to:
            msg['Reply-To'] = reply_to
        else:
            msg['Reply-To'] = msg['From']

        if email_bcc:msg['Bcc'] = email_to
        else:msg['To'] = email_to
        msg['Date'] = formatdate(localtime=True)
        msg['X-Priority']='3 (Normal)'

        if html2text and subtype == 'html':
            text = html2text(email_body.decode('utf-8')).encode('utf-8')
            alternative_part = MIMEMultipart(_subtype="alternative")
            alternative_part.attach(MIMEText(text, _charset='utf-8', _subtype='plain'))
            alternative_part.attach(email_text)
            msg.attach(alternative_part)
        else:
            msg.attach(email_text)
        if emailobject.store_fname:
            part = MIMEBase('application', "octet-stream")
            fcontent=smtp_server.archive_folder+emailobject.store_fname
            fcontent=open(fcontent,'rb').read()
            part.set_payload( fcontent )
            Encoders.encode_base64(part)
            part.add_header('Content-Disposition', 'attachment; filename="%s"' % (emailobject.store_fname,))
            msg.attach(part)
        e=False
        try:
            oldstderr = smtplib.stderr
            smtplib.stderr = logthis()

            s = smtplib.SMTP()
            s.set_debuglevel(1)  # 0 or 1
            s.connect(smtp_server.host, int(smtp_server.port))
            s.login(smtp_server.username, smtp_server.password)
            s.sendmail(email_from, email_to, msg.as_string())
            ans={'message':'Email Sent Successfully',
                 'state':'sent',
                 'next_act':None,}
            s.quit()
        except smtplib.SMTPException,e:
            e=[smtplib.SMTPException,e]
        except socket.error,(v,m):
            e=[socket.error,v,m]
        if e:
            ans={'message':e,
                 'state':'error',
                 'next_act':(datetime.now() + relativedelta(minutes=next_action)).strftime('%Y-%m-%d %H:%M:%S'),
                 }
        return ans
    def server_queue_scheduler(self, cr, uid, context={}):
        auto_run=1
        forced=0
        total_run=12
        #print "In Server Queue Scheduler..."
        #if str(tools.config.get('netrpc_port', False))==(8070):
            #print "Automated Communication Started For %s Runs"%total_run
            #auto_run=1
        queue_pool = self.pool.get('comm_queue')
        #queue_items_ids = queue_pool.search(cr, uid,[('state', 'in', ['working','error']),('date_action_next','<=',datetime.now().strftime('%Y-%m-%d %H:%M:%S')),('try_count','<',2)],limit=total_run)
        queue_items_ids = queue_pool.search(cr, uid,[('state', '=', 'working'),('try_count','in',['1','0'])],limit=total_run)
        if context.get('force_id',None):
            queue_items_ids=context['force_id']
            forced=1
            auto_run=1
        queue_objs = queue_pool.browse(cr, uid, queue_items_ids)
        if auto_run:
            for queue_obj in queue_objs:
#                print queue_obj.id
                vals={
                    'state': 'error',
                    'job_id':None,
                    'date_action_last': datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
                    'date_action_next': None,
                    }
                queue_pool.write(cr, uid, queue_obj.id, vals)
                t=queue_pool.search(cr, uid, ['&','&','&','&',('type', '=', queue_obj.type),('to','=',queue_obj.to),('content','=',queue_obj.content),('fname','=',queue_obj.fname),('state','!=','error')])
                if not forced:
                    if len(t)>1:#Duplicate Detection
                        values={'state': 'error',
                                'error_msg':'A Similar Message has been sent to this destination!',
                                'try_count':queue_obj.try_count+1,
                                'date_action_last': datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
                                'date_action_next': None,}
                        queue_pool.write(cr, uid, queue_obj.id, values) 
                        continue
                
                try:
                    
                    if queue_obj.type == 'sms':
                        ans=self._send_sms(cr,uid,queue_obj.server_id,queue_obj)
                    if queue_obj.type == 'fax':
                        ans=self._send_fax(cr,uid,queue_obj.server_id,queue_obj)
                    if queue_obj.type == 'email':
                        ans=self._send_mail(cr,uid,queue_obj.server_id,queue_obj)  
#                    print '1',ans
                    values={'state': ans['state'],
                            'error_msg':(queue_obj.error_msg or '')+'\n'+u(ans['message']),
                            'job_id':ans.get('job_id',None),
                            'try_count':queue_obj.try_count+1,
                            'date_action_last': datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
                            'date_action_next': ans['next_act'],
                            }
                except:
                    values={'state': 'error',
                            'error_msg':(queue_obj.error_msg or '')+'\n'+u('LOW LEVEL ERROR'),
                            'job_id':None,
                            'try_count':queue_obj.try_count+1,
                            'date_action_last': datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
                            'date_action_next': None,
                            }
#                    print '2',values
                    
                finally:
#                    print '3 finally',values
                    queue_pool.write(cr, uid, queue_obj.id, values)
                total_run-=1
                if total_run<=0:break
        return True
        #if auto_run:return True
        #else:return False
    def do_done(self, cr, uid, context={}):
        return {}
communication_server()

class communication_templates(osv.osv):
    _name="communication.templates"
    _columns={
        'name': fields.char('Title', size=256, required=True , help="A title for your message"),
        'body' : fields.text('Body',help="Your Message before Rendering"),
        'type':fields.selection([('sms','SMS'),('email','Email')],'Type'),
        'system_message':fields.boolean('System'),
        'email_type':fields.boolean('HTML',help="Send This Email In HTML Format"),
    }
    _defaults={
        'system_message':lambda *a:True,
        'email_type':lambda *a:False,
    
    }

communication_templates()
