# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2010-2012, Tashilgostar co. , All Rights Reserved
#        Nima ghorbani <nima.g.67@gmail.com> (http://ir.linkedin.com/in/nimaghi)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from crm import crm
from osv import osv, fields
from tools.translate import _

import base64
import sys,os,random
import subprocess
from Communication.render import srender as render

import csv

class import_queue(osv.osv_memory):
    """Communication Import Queue"""
    
    _name = 'communicate.import'
    _description = 'Import Custom .CSV Contacts with Rendering Capability'
    _inherit='communicate'
    def default_get(self, cr, uid, fields, context=None):
        return {}
    
    _columns = {
        'to_file' : fields.binary('To .CSV', filters='*.csv'),
        'to_file_name' : fields.char('name', size=128),
    }
    
    def read_csv(sef,filename):
        #vals['at_name']=generated_name+'.'+suffix
        with open(filename,'rb') as arg_file:
            _args = csv.reader(arg_file, delimiter=',')
            result={}
            firstline=True
            count=0
            for row in _args:
                if firstline:
                    columns=row
                    firstline=False
                else:
                    temp={}
                    for col in columns:
                        temp[col]=row.pop(0)
                    count+=1
                    result[count]=temp
        return result
        
    def import_queue(self, cr, uid, ids, *args):
        form = self.browse(cr, uid, ids)[0]
        vals={ #Setting Common Attributes
            'type':form.type,
            'server_id':form.server_id.id,
            'system_message':False,}
        if form.at_name:#Handling Attachment
            fname,suffix=self.get_suffix(form.at_name)
            generated_name=''.join([str(random.randint(0,1000)) for i in range(0,3)])
            n_filename = form.server_id.archive_folder + generated_name
            filename=n_filename+'.'+suffix
            with open(filename, "wb") as pf:
                pf.write(base64.decodestring(form.attachment))
            if suffix !='pdf' and form.type=="fax":
                try:
                    self.convert_office(filename)
                    suffix='.pdf'
                except:
                    return {'warning':{'title':'Not Suitable File','message':'The attachment submitted if not suitable and cannot be converted'}}
            vals['at_name']=generated_name+'.'+suffix
            
        model_map={'sms':'mobile','fax':'phone','email':'email'}
        fname,suffix=self.get_suffix(form.to_file_name)
        generated_name=''.join([str(random.randint(0,1000)) for i in range(0,3)])
        n_filename = '/tmp/' + generated_name
        filename=n_filename+'.'+suffix
        with open(filename, "wb") as pf:pf.write(base64.decodestring(form.to_file))
        args_pool=self.read_csv(filename)
        for args in args_pool.iterkeys():
            to=args_pool.get(args,{})
            print to,model_map.get(form.type,'')
            text=render(form.text,to)
            to_dest=to.get(model_map[form.type], None)
            if to_dest:
                vals.update({
                    'to':to_dest,
                    'content': text,
                    'email_subject':form.subject or None,
                    'email_type':((form.html and 'html') or 'plain') or None,}) 
                previous_communications_ids=self.pool.get('comm_queue').search(cr, uid, [('to', 'ilike',to_dest)])
                previous_communications=self.pool.get('comm_queue').browse(cr, uid, previous_communications_ids)
                for p in previous_communications:
                    vals.update({
                    'model':p.model,
                    'object_id': p.object_id,})
                    print p.id
                    break
                self.pool.get('comm_queue').create(cr,uid,vals=vals)
        return {}


import_queue()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

