# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2010-2012, Tashilgostar co. , All Rights Reserved
#        Nima ghorbani <nima.g.67@gmail.com> (http://ir.linkedin.com/in/nimaghi)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from crm import crm
from osv import osv, fields
from tools.translate import _

import base64
import sys,os,random
import subprocess
from Communication.render import render
import random,string,os



class communicate(osv.osv_memory):
    """Communication Manager"""

    _name = 'communicate'
    _description = 'Communicate with outer world'
    def random_name(self,cr=None):
        '''Make a unique name.if cr!=None check the database for this random name and make sure it does not exist'''
        random.seed()
        if cr:
            while 1:
                res="".join([random.choice(string.ascii_letters) for x in xrange(10) ])
                cr.execute('SELECT id from comm_queue WHERE at_name=%s',(res,))
                if cr.fetchall():continue
                else:return res
        return "".join([random.choice(string.ascii_letters) for x in xrange(10) ])
    def default_get(self, cr, uid, fields, context=None):
        vals={}
        if context is None:
            context = {}
        crm_obj = self.pool.get('crm.lead')
        model=context.get('active_model',None)
        address_ids=[]
        if model== "res.users":
            address_ids=[]
            users=self.pool.get(context.get('active_model',None)).browse(cr,uid,context.get('active_ids',None))
            for user_id in users:
                address_ids.append(user_id.address_id.id)
        model_map={
            'crm.lead':{'form_to':'crm_ids','email':'email_from','fax':'fax','sms':'mobile'},
            'res.partner':{'form_to':'partner_ids','email':'email','fax':'fax','sms':'mobile','object_id':'partner_id.'},
            'res.partner.contact':{'form_to':'contact_ids','email':'email','fax':'fax','sms':'mobile'},
            'hr.employee':{'form_to':'employees_ids','email':'work_email','fax':None,'sms':'mobile_phone'},
            'hr.applicant':{'form_to':'applicant_ids','email':'email_from','fax':'partner_phone','sms':'partner_mobile'},
            'res.users':{'form_to':'user_ids','email':'email','fax':'phone','sms':'mobile','object_id':'partner_id.'},}
        if model=='res.partner':
            vals['partner_ids']=self.pool.get('res.partner.address').search(cr,uid,[('partner_id','in',context.get('active_ids',None))])
        
        elif model=='project.task':
            tasks=self.pool.get('project.task').browse(cr,uid,context.get('active_ids',None))
            partner_ids=[task.project_id.partner_id.id or None for task in tasks]  
            if partner_ids:
                vals['partner_ids']=self.pool.get('res.partner.address').search(cr,uid,[('partner_id','in',partner_ids)])
        elif model=='event.registration':
            registrations=self.pool.get('event.registration').browse(cr,uid,context.get('active_ids',None))
            partner_ids=[registration.partner_id.id or None for registration in registrations]  
            if partner_ids:
                vals['partner_ids']=self.pool.get('res.partner.address').search(cr,uid,[('partner_id','in',partner_ids)])        
        else:
            vals[model_map[model]['form_to']]=context.get('active_ids',None)
        vals.update({
            'user_ids':address_ids,
            'model':model
            })
        return vals
        
    def u(self,obj, encoding='utf-8'):
        if isinstance(obj, basestring):
            if not isinstance(obj, unicode):
                obj = unicode(obj, encoding)
        return obj
    def get_suffix(self,fname):
        suffix=fname.split('.')
        if len(suffix)!=2:raise osv.except_osv(_('Printer Manger - Error!'), _('Should not use "." in filename %s!!!' % fname))
        return suffix[0],suffix[1].lower()
    def convert_office(self,tempf):
        cmdconv='unoconv -f pdf '+tempf
        pipe = subprocess.Popen(cmdconv, stdout=subprocess.PIPE,stderr=subprocess.PIPE, shell=True)
        sts = pipe.wait()
        err= pipe.stderr.read()
        print err
        if err: raise osv.except_osv(_('Printer Manger - Error!'), _('The provided document cannot be converted to the desired format.'))
    def on_change_type(self, cr, uid, ids, s_type=None,context={}):
        #TODO: change the context of comm_server search to the selected type
        server_ids = self.pool.get('comm_server').search(cr, uid, [('type','=',s_type),('default_server','=',True)])
        if server_ids:
            return {'value': {'server_id':server_ids.pop()}}
        return {'warning':{'title':'No Server','message':'No Default server is defined for this kind of communication'}}
        #return {'context':{'type': 'sms'}}
    def on_change_template(self, cr, uid, ids, template_id=None,context={}):
        text = self.pool.get('communication.templates').browse(cr, uid,template_id )
        return {'value': {'text':text.body}}
  
    def make_queue(self, cr, uid, ids, *args):
        form = self.browse(cr, uid, ids)[0]
        vals={ #Setting Common Attributes
            'type':form.type,
            'server_id':form.server_id.id,
            'model':str(form.model),
            'system_message':False,}
        if form.at_name:#Handling Attachment
            fname,suffix=self.get_suffix(form.at_name)
            generated_name=self.random_name(cr)
            n_filename = form.server_id.archive_folder + generated_name
            filename=n_filename+'.'+suffix
            with open(filename, "wb") as pf:
                pf.write(base64.decodestring(form.attachment))
            if suffix !='pdf' and form.type=="fax":
                try:
                    self.convert_office(filename)
                    suffix='.pdf'
                except:
                    return {'warning':{'title':'Not Suitable File','message':'The attachment submitted if not suitable and cannot be converted'}}
            vals.update({
                'store_fname':generated_name+'.'+suffix,
                'fname':form.at_name,
                'file_size':len(form.attachment),
            })
        model_map={
            'crm.lead':{'form_to':'crm_ids','email':'email_from','fax':'fax','sms':'mobile'},
            'res.partner':{'form_to':'partner_ids','email':'email','fax':'fax','sms':'mobile','object_id':'partner_id.'},
            'res.partner.contact':{'form_to':'contact_ids','email':'email','fax':'fax','sms':'mobile'},
            'hr.employee':{'form_to':'employees_ids','email':'work_email','fax':None,'sms':'mobile_phone'},
            'hr.applicant':{'form_to':'applicant_ids','email':'email_from','fax':'partner_phone','sms':'partner_mobile'},
            'res.users':{'form_to':'user_ids','email':'email','fax':'phone','sms':'mobile','object_id':'partner_id.'},
            'project.task':{'form_to':'partner_ids','email':'email','fax':'phone','sms':'mobile','object_id':''},
            'event.registration':{'form_to':'partner_ids','email':'email','fax':'phone','sms':'mobile','object_id':''},
        }
        to=model_map[form.model]['form_to']
        for to in eval("form."+to):
            if form.template_id:
                text=render(cr,uid,eval('to.'+model_map[form.model].get('object_id','')+'id'),form.text,form.model)
            else: text=form.text
            to_dest=eval('to.'+model_map[form.model][form.type]) or None
            if to_dest:
                vals.update({
                    'to':to_dest,
                    'object_id':eval('to.'+model_map[form.model].get('object_id','')+'id'),
                    'content': text,
                    'email_subject':form.subject or None,
                    'email_type':((form.html and 'html') or 'plain') or None,})  
                self.pool.get('comm_queue').create(cr,uid,vals=vals)
        return {}
    
    _columns = {
        'crm_ids' : fields.many2many('crm.lead',  'communication_rel', 'queue_id', 'crm_id', 'CRM'),
        'event_ids' : fields.many2many('event.registration',  'communication_rel', 'queue_id', 'event_id', 'Event REgistrations'),
        'task_ids' : fields.many2many('project.task',  'communication_rel', 'queue_id', 'task_id', 'Tasks'),
        'partner_ids' : fields.many2many('res.partner.address',  'communication_rel', 'queue_id', 'patner_id', 'Partners'),
        'contact_ids' : fields.many2many('res.partner.contact',  'communication_rel', 'queue_id', 'contact_id', 'Contacts'),
        'employees_ids' : fields.many2many('hr.employee',  'communication_rel', 'queue_id', 'employee_id', 'Employees'),
        'applicant_ids' : fields.many2many('hr.applicant',  'communication_rel', 'queue_id', 'employee_id', 'Applicants'),
        'user_ids' : fields.many2many('res.partner.address',  'communication_rel', 'queue_id', 'user_id', 'Users'),
        'type':fields.selection([
            ('email', 'Email'),
            ('sms', 'SMS'),
            ('fax', 'Fax'),
            ], 'Communicate via', readonly=False,required=True),
        'model':fields.selection([
            ('crm.lead', 'CRM'),
            ('res.partner', 'Partner'),
            ('res.partner.contact', 'Contacts'),
            ('hr.employee', 'Employee'),
            ('hr.applicant', 'Applicant'),
            ('res.users', 'User'),
            ('project.task', 'Partner'),
            ('event.registration','Partner'),
            ], 'Model', readonly=True,required=True),
        'credit': fields.integer('SMS Credit'),
        #'mass':fields.boolean('Mass'),
        'html':fields.boolean('HTML',help='Send as HTML'),
        'template_id': fields.many2one('communication.templates','Template'),
        'attachment' : fields.binary('Document', filters='*.pdf,*.doc,*.docx,*.*'),
        'at_name' : fields.char('name', size=128),
        'text': fields.text('Message'),
        'server_id':fields.many2one('comm_server','Server',required=True,),
        'subject': fields.char('Subject',size=256),
    }


communicate()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
